#by Shrim
'''пример использования модуля uidcrc
найдём где находяться уиды, попробуем посчитать их контрольную сумму
ну и немного поразмыслим о том что же это вообще такое и с чем их едят'''
import uidcrc
import appuifw

def str_to_int(L):
   '''байты уидов расположены в Big-endian т.е. "сзаду наперёд"
   поэтому чтобы строку содержащую уид преобразовать в число
   надо развернуть байты в Little-endian т.е. в привычный нам вид
   потом строку необходимо преобразовать в шестнадцатиричный вид
   и затем уже преобразовывать в число, причем не int а long
   так как длины int обычно бывает недостаточно'''
   L = L[3:4]+L[2:3]+L[1:2]+L[0:1]   #разворачиваем из Little-endian в Big-endian
   L = L.encode('hex')               #декодируем из строки в шестнадцатиричный вид (hex)
   L = long(L,16)                    #преобразуем из hex в число
   return L                          #возвращаем полученое число

python_path = appuifw.app.full_name()   #получаем путь к .app файлу питона
file = open(python_path)                #открываем .app файл
uid1 = file.read(4)                     #считываем первые четыре байта ([0:4]), это первый уид
uid1 = str_to_int(uid1)                 #преобразуем считаные байты в число
uid2 = file.read(4)                     #считываем вторые четыре байта ([4:8]), это второй уид
uid2 = str_to_int(uid2)                 #преобразуем считаные байты в число
#первый и второй уид являются идентификаторами по которым система выставляет ассоциации
uid_3 = file.read(4)                    #считываем третие четыре байта ([8:12]), это третий уид
uid3 = str_to_int(uid_3)                #преобразуем считаные байты в число
#третий уид является идентификатором приложения, заметьте, на этот раз сохраняем значение считаных байтов
#чтоб потом поискать его в оставшейся части файла
#в случае совпадения третих уидов у разных программ в системе происходит конфликт между ними
uid4 = file.read(4)                     #считываем четвёртые четыре байта ([12:16])
#это контрольная сумма уидов, которую частенько называют четвёртым уидом
crc = uidcrc.sum(uid1, uid2, uid3)      #подсчитываем контрольную сумму уидов
if uid4 == crc:                         #если контрольная сумма считаная из файла и посчитаная модулем uidcrc совпадают
   print "uid4 = crc"                   #выводим сообщение о удачном подсчёте
txt=file.read()                         #считываем файл до конца
file.close()                            #и закрываем его
if txt.find(uid_3) != -1:               #если в оставшейся части файла третий уид повторяется ещё раз
   print "find two uid3"                #сообщаем об этом

'''Обычно в .app файлах третий уид (идентификатор приложения) прописан два раза.
Все эти заморочки с конрольными суммами, прописыванием уида в двух местах и ещё некоторые приколы
сделаны для защиты файлов (приложений) от порчи и для защиты системы.
Так что нам приходиться только мириться с этим и разбираться как оно работает.
Надеюсь я понятно разъяснил что такое уиды и с чем их едят.
Хотя в большинстве случаев даже не обязательно это знать, просто надо знать где они находяться
и как посчитать их контрольную сумму, что я в принципе и постарался показать.
Конечно можно ещё рассказать о том что первый и второй уид обычно свойственны для каждого вида файлов,
для .app они одни, для .aif уже другие, для .dll третьи ну и т.д. можно ещё сказать что третьи уиды программ
обычно начинаються с 101 , хотя не всегда - не все программисты используют официальные уиды
которые по идее надо заказывать у Nokia - программистам просто лень это делать и они пишут уиды наугад
я и сам так делаю =)) Многое ещё можно рассказать про эти загадочные циферки, но считаю что 
не стоит захламлять этим свой мозг.
С уважением
Shrim'''
